/* 
 
    (c) 2003-2006 Cyborg 

    {* String: Version="$VER: linuxclient (C) CYBORG 2006"*}

*/

#include "os.h"
#include "newgui_lib.h"
#include "defines.h"
#include "amiga.h"
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <syslog.h>
#include <memory.h>

long packetsize;
int port=1999;
char *hostname = "localhost";

void log_error(int l,char *msg) {
    if (l==LOG_ERR) {
        printf("Error: %s\n",msg);
    } else {
        printf("Warning: %s\n",msg);
    }
    
}

hexdump(char *von,long len) {
    int i,j;

    if (von==NULL) { 
        printf("HexDump: NULL-POINTER\n");
        return;
    }

    for(i=0;i<len;i+=8) {
        printf("%04d. ",i);
        for(j=0;j<8 && (i+j)<len;j++) {
            printf("%02x",(von[i+j])&0xff);
            if (j==3) printf(" ");
        }
        printf(" ");
        for(j=0;j<8 && (i+j)<len;j++) {
            if ( von[i+j]>0x1f && von[i+j]<127) {
                printf("%c",von[i+j]);
            } else printf(".");
        }
        printf("\n");
    }
}

long tagsize(long *tags) {
    long   c = 1;
    int  idx = 0;

    while (tags[idx]!=0) {
        idx+=2; // idx zeigt auf TAG --- 8 Bytes = TAG + TAG_DATA
        c++;
    }

    return c;
}


long big(long le) {

#if BIGENDIAN
    return le;
#else
    return  ((le&0xFF)<<24) + ((le&0xFF00)<<8) + ((le&0xFF0000)>>8) + ((le&0xFF000000)>>24);
#endif

}

/* Verbindung zum Server setzen */

int myconnect(char *host, int port)
{
  struct sockaddr_in adr;
  struct hostent* hostent;

  int result,i;
  int s;
 
  memset((void *) &adr,0,sizeof(adr));
  s = socket(AF_INET, SOCK_STREAM, 0);
  if (s < 0) {
    log_error(LOG_ERR,"socket kann nicht erstellt werden");
    return -1;
  }


  if (!(hostent = gethostbyname(host))) {
    close(s);
    log_error(LOG_ERR, "unknown host");
    return -1;
  }

  adr.sin_addr.s_addr  = *(long*) hostent->h_addr_list[0];
  adr.sin_family       = AF_INET;
  adr.sin_port         = htons(port);

  result = connect(s, (struct sockaddr*) &adr, sizeof(adr));

  if(result < 0)
    {
      close(s);
      log_error(LOG_ERR, strerror(errno));
      return result;
    }
  return s;
}

int mydisconnect(int s)
{
  int result;

  result=close(s);
  if (result < 0) {
    log_error(LOG_ERR,"socket konnte nicht geschlossen werden!");
  }
  return result;
}


long mysend(int s,char *msg,long msglen,int flags) {

    struct timeval tv;
    long wr,olen=msglen,prozent;
    int i=0;
//    fd_set rfds;
    fd_set wfds;
//    FD_ZERO(&rfds);

    int psize=0;

    while (msglen>0) 
     {
       tv.tv_sec  = 10;
       tv.tv_usec = 100000;

       FD_ZERO(&wfds);
       FD_SET(s,&wfds);

       wr=select(s+1,0,&wfds,0,&tv);
       if (wr<0 || !FD_ISSET(s,&wfds)) {
           printf("mysend: Socket nicht bereit zum Schreiben %d\n",errno);
           return olen-msglen;
       }   
        
       if (msglen>32768) {
           wr=send(s,msg,32768,flags);
       } else wr=send(s,msg,msglen,flags);


       prozent=((olen-msglen)*100/olen);
//       printf("mysend  %u%% wr=%d olen=%d msglen=%d\r",prozent,wr,olen,msglen);
       
       if (wr<1)
        {
          printf("mysend: i=$d error=%d\n",errno);
          if (i>3) return olen-msglen;
          
          i=i+1;

        
        } else {

           msg=msg+wr;
           msglen=msglen-wr;
           i=0;
        }
       
     }

//    printf("mysend 100%% wr=%d olen=%d msglen=%d\n",prozent,wr,olen,msglen);

    return olen;
}


long myrecv(int s,char *zeiger,long laenge,int time) {

    int readlen=0;

    while (time>0) 
     {
       readlen=recv(s,zeiger,laenge,0);
       if (readlen>0) return readlen;
       time=time-5;
       sleep(5);
     }
    
    return readlen;
}

char *CreateTPacket(char *name,char *von,char *bis) {

    char *mem;
    long packetsize;
    char *mem_p;
    long *p;
    long value;
    int i;
    

    packetsize=bis-von+8;

    mem=malloc(packetsize+4);
    if (mem)
     {
       p=(long *)mem;
       
       mem_p=mem+ARGBASE;
    
       p[0]=packetsize;       
       p[1]=big(0x4E474C43); // <- NGLC
       p[2]=big(bis-von);

       memcpy(mem_p,von,bis-von);
       return mem;      
     }

    return NULL;

}


long *WaitForAktion(char *fname,char *hostname,int port,char *packet,long packetsize,int args) {

    char *mem;
    int socket;
    int tmp=1;
    long len=0,func=0;
    long *header = (long *)malloc(8);

    if ((socket=myconnect(hostname,port))!=-1) {
    
        setsockopt(socket,SOL_SOCKET,SO_KEEPALIVE,&tmp,4);

/*        if (packetsize<200) {
            hexdump(packet,packetsize);
        } else hexdump(packet,200);
*/

        header[0]=big(0x4E474C43); // <- NGLC
        header[1]=big(packetsize);

        mysend(socket,(char *)header,8,500);
        len=mysend(socket,packet,packetsize,500);

        if (len!=packetsize) printf("ERROR: WaitforAktion.%s %u von %u gesendet\n",fname,len,packetsize);

        if (len==packetsize && args>0) {

	        free(header);

            header = (long *)packet;
            func=big(header[0]);
    
	        free(packet);
	
            if (func<0) {

                args=args*4;
                mem=malloc(args);
                memset(mem,0,args);

                len=myrecv(socket,mem,args,250);

            // printf("WaitforAktion %lu gelesen\n",*len)

            }
            if (func==1) {

                mem=malloc(32769);
                memset(mem,0,32769);
                len=myrecv(socket,mem,32768,250);
            }

            mydisconnect(socket);
            return (long *)mem;

        } 
	free(packet);
	free(header);

        mydisconnect(socket);
     }
 
    return NULL;

}

long *ngcommand(char *name,char *von,long len,int returns) {

/*
    char *p;
    long l;

    p=CreateTPacket(name,von,von+len);
    
    l=((long *)p)[0];
    p=p+4;
*/


    
    return (long *)WaitForAktion(name,hostname,port,von,len,returns);

}


long *open_Window(long l,long t,long w,long h,char *title,long flags,long idcmp) {
/*
packet2:
    dc.l fc_open_window,8
    dc.l LABEL_D0,INT,LONG,100
    dc.l LABEL_D1,INT,LONG,11
    dc.l LABEL_D2,INT,LONG,640
    dc.l LABEL_D3,INT,LONG,501
    dc.l LABEL_A0,POINTER,6
    dc.b "DEMO5",0
    dc.l LABEL_D4,INT,LONG,WFLG_DRAGBAR!WFLG_REPORTMOUSE!WFLG_DEPTHGADGET!WFLG_CLOSEGADGET!WFLG_RMBTRAP!WFLG_SMART_REFRESH
    dc.l LABEL_D5,INT,LONG,IDCMP_MOUSEBUTTONS!IDCMP_ACTIVEWINDOW!IDCMP_MOUSEMOVE
    dc.l LABEL_A1,POINTER,24,NG_THEMEABLE,1,NG_THEME_ID,7,TAG_DONE,NULL
*/

    int  slen = strlen(title)+1;
    long size = 8 + 6*ARGINT + ARGBASE+slen + ARGBASE+24;

    char *msgo =  malloc (size);

    long *msg=(long *)msgo;

    msg[0]=big(fc_open_window);
    msg[1]=big(8);
    msg[2]=big(LABEL_D0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=big(l);
    msg[6]=big(LABEL_D1);msg[7]=big(INT);msg[8]=big(LONG);msg[9]=big(t);
    msg[10]=big(LABEL_D2);msg[11]=big(INT);msg[12]=big(LONG);msg[13]=big(w);
    msg[14]=big(LABEL_D3);msg[15]=big(INT);msg[16]=big(LONG);msg[17]=big(h);

    msg[18]=big(LABEL_A0);msg[19]=big(POINTER);msg[20]=big(slen);
        
    msg= (long *)((long )msg+21*4);
    memcpy( (char *)msg, title,slen);
    msg= (long *)((long )msg+slen);

    
    msg[0]=big(LABEL_D4);msg[1]=big(INT);msg[2]=big(LONG);msg[3]=big(flags);
    msg[4]=big(LABEL_D5);msg[5]=big(INT);msg[6]=big(LONG);msg[7]=big(idcmp);

    msg[8]=big(LABEL_A1);msg[9]=big(POINTER);msg[10]=big(24);
    msg[11]=big(NG_THEMEABLE);
    msg[12]=big(1);
    msg[13]=big(NG_THEME_ID);
    msg[14]=big(7);
    msg[15]=TAG_DONE;
    msg[16]=0;
    
    return (long *)ngcommand("open_window",msgo,size,1);
}    

long *close_Window(long newgui) {
    
/*
packet3:
    dc.l close_window,1
    dc.l LABEL_D0,INT,LONG,ARG
*/
    long size = 8 + 1*ARGINT;

    char *msgo =  malloc (size);

    long *msg=(long *)msgo;

    msg[0]=big(fc_close_window);
    msg[1]=big(1);
    msg[2]=big(LABEL_D0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;
    
    return (long *)ngcommand("close_window",msgo,size,0);
}    

long *workGui(long newgui,long *tags) {
/*
packet4:
    dc.l workgui,2
    dc.l LABEL_A0,INT,LONG,ARG
    dc.l LABEL_A1,INT,LONG,ARG
*/

    long size = 8 + 1*ARGINT;

    if (tags==NULL) {
        size=size+ARGBASE+LONG;
     } else {
        size=size+ARGBASE+tagsize(tags)*8;
    }

    char *msgo =  malloc (size);

    long *msg=(long *)msgo;

    msg[0]=big(fc_workgui);
    msg[1]=big(2);
    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;
    if (tags!=NULL) {
    
    	msg[6]=big(LABEL_A1);msg[7]=big(POINTER);msg[8]=big(tagsize(tags)*8);
        msg= (long *)((long )msg+36);
        memcpy( (char *)msg, tags, tagsize(tags)*8);
        msg= (long *)((long )msg+tagsize(tags)*8);

    } else {

    	msg[6]=big(LABEL_A1);msg[7]=big(INT);msg[8]=big(LONG);msg[9]=0;

    }

    return (long *)ngcommand("workgui",msgo,size,0);
}    

long *clearGui(long newgui) {
/*
    dc.l cleargui,1
    dc.l LABEL_A0,INT,LONG,0
*/

    long size = 8 + 1*ARGINT;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[0]=big(fc_cleargui);
    msg[1]=big(1);
    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;

    return (long *)ngcommand("cleargui",msgo,size,0);
}    
    

long *getPressedKey(long newgui) {
/*
    dc.l getPressedKey,1
    dc.l LABEL_A0,INT,LONG,ARG
*/
    long size = 8 + 1*ARGINT;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[0]=big(fc_getpressedkey);
    msg[1]=big(1);
    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;

    return (long *)ngcommand("getPressedKey",msgo,size,1);
}    

long *getPressedCode(long newgui) {
    long size = 8 + 1*ARGINT;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[0]=big(fc_getpressedcode);
    msg[1]=big(1);
    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;

    return (long *)ngcommand("getPressedCode",msgo,size,1);
}    

long *getGadgetStatus(long newgui,long gadnbr) {
/*
    dc.l getPressedKey,1
    dc.l LABEL_A0,INT,LONG,ARG
*/
    long size = 8 + 2*ARGINT;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[0]=big(fc_getgadgetstatus);
    msg[1]=big(2);
    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;
    msg[6]=big(LABEL_D0);msg[7]=big(INT);msg[8]=big(LONG);msg[9]=big(gadnbr);

    return (long *)ngcommand("getGadgetStatus",msgo,size,1);
}    

long *FreeDeep(long deep) {
/*
    dc.l FreeDeep,1
    dc.l LABEL_A0,INT,LONG,ARG
*/
    long size = 8 + 1*ARGINT;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[0]=big(fc_freedeep);
    msg[1]=big(1);
    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=deep;

    return (long *)ngcommand("getPressedKey",msgo,size,0);
}    

long *WaitGuiEvent(long newgui,long *tags) {
/*
    dc.l WaitGuiEvent,2
    dc.l LABEL_A0,INT,LONG,ARG
    dc.l LABEL_A1,INT,LONG,0
packet8:
*/
    long size = 8 + 1*ARGINT;

    if (tags==NULL) {
        size=size+ARGBASE+LONG;
     } else {
        size=size+ARGBASE+tagsize(tags)*8;
    }

    char *msgo =  malloc (size);

    long *msg=(long *)msgo;

    msg[0]=big(fc_waitguievent);
    msg[1]=big(2);
    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;
    if (tags!=NULL) {
    
    	msg[6]=big(LABEL_A1);msg[7]=big(POINTER);msg[8]=big(tagsize(tags)*8);
	    msg= (long *)((long )msg+36);
        memcpy( (char *)msg, tags, tagsize(tags)*8);
    } else {
    	msg[6]=big(LABEL_A1);msg[7]=big(INT);msg[8]=big(LONG);msg[9]=0;
    }

    return (long *)ngcommand("WaitGuiEvent",msgo,size,2);
}    

long *UpdateGui(long newgui,long *tags) {
/*
packet7:
    dc.l UpdateGui,2
    dc.l LABEL_A0,INT,LONG,ARG
    dc.l LABEL_A1,POINTER,16,NG_BACKGROUND_IMAGE,ARG,TAG_done,null

*/
    long size = 8 + 1*ARGINT;

    if (tags==NULL) {
        size=size+ARGBASE+LONG;
     } else {
        size=size+ARGBASE+tagsize(tags)*8;
    }

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;
    msg[0]=big(fc_updategui);
    msg[1]=big(2);
    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;

    if (tags!=NULL) {
   
    	msg[6]=big(LABEL_A1);msg[7]=big(POINTER);msg[8]=big(tagsize(tags)*8);
    	msg= (long *)((long )msg+36);
        memcpy( (void *)msg, tags, tagsize(tags)*8);

    } else {
    	msg[6]=big(LABEL_A1);msg[7]=big(INT);msg[8]=big(LONG);msg[9]=0;
    }

    return (long *)ngcommand("UpdateGui",msgo,size,0);
}    


long *CreateDeep(long newgui,char *filename) {
/*
    dc.l CreateDeep,2
    dc.l LABEL_A0,INT,LONG,ARG
    dc.l LABEL_A1,FILE_CACHE,4+10+4+file1e-file1s,10
    dc.b "t:aa.deep",0
    dc.l file1e-file1s
file1s:
    incbin "sources:ngserver/test.deep"
file1e:
*/
    long fsize;
    long size;
    char *msgo;
    long *msg;
    char *tname = tmpnam(NULL);

    char *tname1= malloc(strlen(tname)+2);
    sprintf(tname1,"t:%s",(tname+5));

    FILE *fh = fopen(filename,"r");
    if (fh<0) {
        printf("Konnte File %s nicht ffnen\n",filename);
        return NULL;
    }

    fseek(fh,0,SEEK_END);
    fsize=ftell(fh);
    fseek(fh,0,SEEK_SET);

    if (fsize==0) {
        printf("Filesize von %s = 0\n",filename);   
        fclose(fh);
        return NULL;
    }

    size = 8 + ARGINT + ARGBASE+ + 4 + strlen(tname1)+1 + 4 + fsize;
    msgo =  malloc (size);
    msg  =(long *)msgo;

    msg[0]=big(fc_createdeep);
    msg[1]=big(2);
    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;
    msg[6]=big(LABEL_A1);msg[7]=big(FILE_CACHE);msg[8]=big(4+strlen(tname1)+1+fsize);
    msg[9]=big(strlen(tname1)+1);

    msg= (long *)((long )msg+40);
    memcpy( (char *)msg,tname1,strlen(tname1)+1);
    msg= (long *)((long )msg+strlen(tname1)+1);
    msg[0]=big(fsize);
    
    fread( (void *)msg+4,fsize,1,fh);

    fclose(fh);

    return (long *)ngcommand("CreateDeep",msgo,size,1);
}    


long *CreateGadgetGeneric(long newgui,long left,long top,long width,long height,char *text,long upimage,long moimage,long downimage,
			  char *class,long *tags) {

/*

packet6:
    dc.l CreateGadgetGeneric,11
    dc.l LABEL_A0,INT,LONG,ARG
    dc.l LABEL_D0,INT,LONG,10
    dc.l LABEL_D1,INT,LONG,10
    dc.l LABEL_D2,INT,LONG,100
    dc.l LABEL_D3,INT,LONG,13
    dc.l LABEL_A1,POINTER,3
    dc.b "OK",0
    dc.l LABEL_D4,INT,LONG,0
    dc.l LABEL_D5,INT,LONG,0
    dc.l LABEL_D6,INT,LONG,0
    dc.l LABEL_A2,POINTER,15
    dc.b "button.library",0
    dc.l LABEL_A3,POINTER,16,NG_TEXT_POS,NG_CENTER,TAG_DONE,NULL
packet9:

*/
    long text_size=strlen(text)+1;
    long class_size=strlen(class)+1;
    long size = 8 + 8*ARGINT + 2*ARGBASE + text_size + class_size;


    if (tags==NULL) {
        size=size+ARGBASE+LONG;
     } else {
        size=size+ARGBASE+tagsize(tags)*8;
    }

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[0]=big(fc_creategadgetgeneric);
    msg[1]=big(11);
    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;
    msg[6]=big(LABEL_D0);msg[7]=big(INT);msg[8]=big(LONG);msg[9]=big(left);
    msg[10]=big(LABEL_D1);msg[11]=big(INT);msg[12]=big(LONG);msg[13]=big(top);
    msg[14]=big(LABEL_D2);msg[15]=big(INT);msg[16]=big(LONG);msg[17]=big(width);
    msg[18]=big(LABEL_D3);msg[19]=big(INT);msg[20]=big(LONG);msg[21]=big(height);
    msg[22]=big(LABEL_A1);msg[23]=big(POINTER);msg[24]=big(text_size);

    msg= (long *)((long )msg+(25*4));
    memcpy( (void *)msg, text, text_size);
    msg= (long *)((long )msg+text_size);

    msg[0]=big(LABEL_D4);msg[1]=big(INT);msg[2]=big(LONG);msg[3]=upimage;
    msg[4]=big(LABEL_D5);msg[5]=big(INT);msg[6]=big(LONG);msg[7]=moimage;
    msg[8]=big(LABEL_D6);msg[9]=big(INT);msg[10]=big(LONG);msg[11]=downimage;

    msg[12]=big(LABEL_A2);msg[13]=big(POINTER);msg[14]=big(class_size);
    msg= (long *)((long )msg+(15*4));
    memcpy( (void *)msg, class, class_size);
    msg= (long *)((long )msg+class_size);

    if (tags!=NULL) {
    	msg[0]=big(LABEL_A3);msg[1]=big(POINTER);msg[2]=big(tagsize(tags)*8);
    	msg= (long *)((long )msg+3*4);
        memcpy( (void *)msg, tags, tagsize(tags)*8);
    } else {
    	msg[0]=big(LABEL_A3);msg[1]=big(INT);msg[2]=big(LONG);msg[3]=0;
    }


    return (long *)ngcommand("CreateGadget",msgo,size,2);
}

// ------------------ U N T E S T E T --- Should work by Copy & Paste :)

long *PlaceDeep(long newgui,long left,long top,char *filename) {
/*
PlaceDeep(Gui,left,top,name)(a0,d0,d1,a1)
*/
    long fsize;
    long size;
    char *msgo;
    long *msg;
    char *tname = tmpnam(NULL);

    char *tname1= malloc(strlen(tname)+2);
    sprintf(tname1,"t:%s",(tname+5));

    FILE *fh = fopen(filename,"r");
    if (fh<0) {
        printf("Konnte File %s nicht ffnen\n",filename);
        return NULL;
    }

    fseek(fh,0,SEEK_END);
    fsize=ftell(fh);
    fseek(fh,0,SEEK_SET);

    if (fsize==0) {
        printf("Filesize von %s = 0\n",filename);   
        fclose(fh);
        return NULL;
    }

    size = 8 + 3*ARGINT + ARGBASE+ + 4 + strlen(tname1)+1 + 4 + fsize;
    msgo =  malloc (size);
    msg  =(long *)msgo;

    msg[0]=big(fc_placedeep);
    msg[1]=big(4);
    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;
    msg[6]=big(LABEL_D0);msg[7]=big(INT);msg[8]=big(LONG);msg[9]=big(left);
    msg[10]=big(LABEL_D1);msg[11]=big(INT);msg[12]=big(LONG);msg[13]=big(top);
    
    msg[14]=big(LABEL_A1);msg[15]=big(FILE_CACHE);msg[16]=big(4+strlen(tname1)+1+fsize);
    msg[17]=big(strlen(tname1)+1);

    msg= (long *)((long )msg+18*4);
    memcpy( (char *)msg,tname1,strlen(tname1)+1);
    msg= (long *)((long )msg+strlen(tname1)+1);
    msg[0]=big(fsize);
    
    fread( (void *)msg+4,fsize,1,fh);

    fclose(fh);

    return (long *)ngcommand("PlaceDeep",msgo,size,1);
}    

/*
DrawDeep(Gui,Left,Top,Deep)(a0,d0,d1,a1)
*/

long *DrawDeep(long newgui,long left,long top,long deep) {

    long size = 8 + 4*ARGINT;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[0]=big(fc_drawdeep);
    msg[1]=big(4);
    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;
    msg[6]=big(LABEL_D0);msg[7]=big(INT);msg[8]=big(LONG);msg[9]=big(left);
    msg[10]=big(LABEL_D1);msg[11]=big(INT);msg[12]=big(LONG);msg[13]=big(top);
    msg[14]=big(LABEL_A1);msg[15]=big(INT);msg[16]=big(LONG);msg[17]=deep;

    return (long *)ngcommand("DrawDeep",msgo,size,0);
}    

/*
UsePen(Gui,Red,Green,Blue)(a0,d0,d1,d2)
*/
long *UsePen(long newgui,long r,long g,long b) {

    long size = 8 + 4*ARGINT;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[0]=big(fc_usepen);
    msg[1]=big(4);

    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;
    msg[6]=big(LABEL_D0);msg[7]=big(INT);msg[8]=big(LONG);msg[9]=big(r);
    msg[10]=big(LABEL_D1);msg[11]=big(INT);msg[12]=big(LONG);msg[13]=big(g);
    msg[14]=big(LABEL_D2);msg[15]=big(INT);msg[16]=big(LONG);msg[17]=big(b);

    return (long *)ngcommand("UsePen",msgo,size,0);
}    

/* 
FilledBoxProzent(Gui,Area,Percent)(a0,a1,d0) 
*/
long *FilledBoxProzent(long newgui,long area,long p) {

    long size = 8 + 3*ARGINT;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[0]=big(fc_filledboxprozent);
    msg[1]=big(3);

    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;
    msg[6]=big(LABEL_A1);msg[7]=big(INT);msg[8]=big(LONG);msg[9]=area;
    msg[10]=big(LABEL_D0);msg[11]=big(INT);msg[12]=big(LONG);msg[13]=big(p);

    return (long *)ngcommand("FilledBoxProzent",msgo,size,0);
}    

/*
BlueBoxProzentT(Gui,Area,percent)(a0,a1,d0)
*/
long *BlueBoxProzentT(long newgui,long area,long p) {

    long size = 8 + 3*ARGINT;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[0]=big(fc_blueboxprozentt);
    msg[1]=big(3);

    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;
    msg[6]=big(LABEL_A1);msg[7]=big(INT);msg[8]=big(LONG);msg[9]=area;
    msg[10]=big(LABEL_D0);msg[11]=big(INT);msg[12]=big(LONG);msg[13]=big(p);

    return (long *)ngcommand("BlueBoxProzentT",msgo,size,0);
}    

/*
BlueBoxProzentT(Gui,Area,percent)(a0,a1,d0)
*/
long *BlueBoxProzent(long newgui,long area,long p) {

    long size = 8 + 3*ARGINT;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[0]=big(fc_blueboxprozent);
    msg[1]=big(3);

    msg[2]=big(LABEL_A0);msg[3]=big(INT);msg[4]=big(LONG);msg[5]=newgui;
    msg[6]=big(LABEL_A1);msg[7]=big(INT);msg[8]=big(LONG);msg[9]=area;
    msg[10]=big(LABEL_D0);msg[11]=big(INT);msg[12]=big(LONG);msg[13]=big(p);

    return (long *)ngcommand("BlueBoxProzent",msgo,size,0);
}    

/*
BasicBoxProzent(Gui,Area,percent,withtext,allowred,allowgreen,allowblue,red,green,blue)(a0,a1,d0,d1,d2,d3,d4,d5,d6,d7)
*/
long *BasicBoxProzent(long newgui,long area,long p,long withtext,long allowred,long allowgreen,long allowblue,
                      long r,long g,long b) {

    long size = 8 + 10*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_basicboxprozent);
    msg[idx++]=big(10);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(p);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(withtext);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(allowred);
    msg[idx++]=big(LABEL_D3);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(allowgreen);
    msg[idx++]=big(LABEL_D4);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(allowblue);
    msg[idx++]=big(LABEL_D5);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(r);
    msg[idx++]=big(LABEL_D6);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(g);
    msg[idx++]=big(LABEL_D7);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(b);

    return (long *)ngcommand("BasicBoxProzent",msgo,size,0);
}    

/*
SpeedBox(Gui,Area,maxvalue,value)(a0,a1,d0,d1)
*/
long *SpeedBox(long newgui,long area,long mv,long v) {

    long size = 8 + 4*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_basicboxprozent);
    msg[idx++]=big(4);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(mv);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(v);

    return (long *)ngcommand("SpeedBox",msgo,size,0);
}    

/*
FreeAreaGFX(Area)(a0)
*/
long *FreeAreaGFX(long area) {

    long size = 8 + 1*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_freeareagfx);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;

    return (long *)ngcommand("FreeAreaGFX",msgo,size,0);
}    

/*
FillBox(Gui,Area,Pen)(a0,a1,d0)
*/
long *FillBox(long newgui,long area,long pen) {

    long size = 8 + 3*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_fillbox);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(pen);

    return (long *)ngcommand("FillBox",msgo,size,0);
}    

/*
FillBoxColor(Gui,Area,red,green,blue)(a0,a1,d0,d1,d2)
*/
long *FillBoxColor(long newgui,long area,long r,long g,long b) {

    long size = 8 + 5*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_fillboxcolor);
    msg[idx++]=big(5);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(r);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(g);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(b);

    return (long *)ngcommand("FillBoxColor",msgo,size,0);
}    

/*
GetFromAreaGFX(Area)(a0)
*/
long *GetFromAreaGFX(long area) {

    long size = 8 + 1*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getfromareagfx);
    msg[idx++]=big(5);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;

    return (long *)ngcommand("GetFromAreaGFX",msgo,size,4);
}    

/*
makeAreaGFX(Gui,left,top,right,bottom)(a0,d0,d1,d2,d3)
*/
long *makeAreaGFX(long newgui,long l,long t,long r,long b) {

    long size = 8 + 5*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_makeareagfx);
    msg[idx++]=big(5);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(l);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(t);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(r);
    msg[idx++]=big(LABEL_D3);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(b);

    return (long *)ngcommand("makeAreaGFX",msgo,size,1);
}    

/*
GetPen(Gui,Red,Green,Blue)(a0,d0,d1,d2)
*/
long *GetPen(long newgui,long r,long g,long b) {

    long size = 8 + 4*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getpen);
    msg[idx++]=big(4);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(r);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(g);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(b);

    return (long *)ngcommand("GetPen",msgo,size,1);
}    

/*
DrawBox3dR(Gui,Area)(a0,a1)
*/
long *DrawBox3dR(long newgui,long area) {

    long size = 8 + 2*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_drawbox3dr);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;

    return (long *)ngcommand("DrawBox3dR",msgo,size,0);
}    

/*
DrawBox3d(Gui,Area)(a0,a1)
*/
long *DrawBox3d(long newgui,long area) {

    long size = 8 + 2*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_drawbox3d);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;

    return (long *)ngcommand("DrawBox3d",msgo,size,0);
}    


/*
DrawRoundBox3D(Gui,Area,distance)(a0,a1,d0)
*/
long *DrawRoundBox3D(long newgui,long area,long dist) {

    long size = 8 + 3*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_drawroundbox3d);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(dist);

    return (long *)ngcommand("DrawRoundBox3D",msgo,size,0);
}    

/*
Free_Gadget(Gadget)(a0)
*/
long *Free_Gadget(long gadget) {

    long size = 8 + 1*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_free_gadget);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=gadget;

    return (long *)ngcommand("Free_Gadget",msgo,size,1);
}    

/*
Free_Gadgets(Gui)(a0)
*/
long *Free_Gadgets(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_free_gadgets);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("Free_Gadgets",msgo,size,1);
}    

/*
DrawDeepArea(Gui,Area,Deep)(a0,a1,a2)
*/
long *DrawDeepArea(long newgui,long area,long deep) {

    long size = 8 + 3*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_drawdeeparea);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_A2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=deep;

    return (long *)ngcommand("DrawDeepArea",msgo,size,0);
}    

/*
GhostGadget(Gui,GadgetNr)(a0,d0)
*/
long *GhostGadget(long newgui,long gadgetnr) {

    long size = 8 + 2*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_ghostgadget);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(gadgetnr);

    return (long *)ngcommand("GhostGadget",msgo,size,0);
}    

/*
DeGhostGadget(Gui,GadgetNr)(a0,d0)
*/
long *DeGhostGadget(long newgui,long gadgetnr) {

    long size = 8 + 2*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_deghostgadget);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(gadgetnr);

    return (long *)ngcommand("DeGhostGadget",msgo,size,0);
}    

/*
DrawRoundBox3DR(Gui,Area,distance)(a0,a1,d0)
*/
long *DrawRoundBox3DR(long newgui,long area,long dist) {

    long size = 8 + 3*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_drawroundbox3dr);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(dist);

    return (long *)ngcommand("DrawRoundBox3DR",msgo,size,0);
}    
/*
getPressedQualifier(Gui)(a0)
*/
long *getPressedQualifier(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getpressedqualifier);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("getPressedQualifier",msgo,size,1);
}    
/*
DrawBorder3d(Gui,Area)(a0,a1)
*/
long *DrawBorder3d(long newgui,long area) {

    long size = 8 + 2*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_drawborder3d);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;

    return (long *)ngcommand("DrawBorder3d",msgo,size,0);
}    
/*
DrawBorder3dR(Gui,Area)(a0,a1)
*/
long *DrawBorder3dR(long newgui,long area) {

    long size = 8 + 2*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_drawborder3dr);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;

    return (long *)ngcommand("DrawBorder3dR",msgo,size,0);
}    
/*
BasicDrawBorder3d(Gui,Area,Highred,highgreen,highblue,red,green,blue)(a0,a1,d0,d1,d2,d3,d4,d5)
*/
long *BasicDrawBorder3d(long newgui,long area,long highr,long highg,long highb,
                        long r,long g,long b) {

    long size = 8 + 8*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_basicdrawborder3d);
    msg[idx++]=big(8);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(highr);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(highg);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(highb);
    msg[idx++]=big(LABEL_D3);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(r);
    msg[idx++]=big(LABEL_D4);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(g);
    msg[idx++]=big(LABEL_D5);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(b);

    return (long *)ngcommand("BasicBorder3d",msgo,size,0);
}    
/*
RemoveGuiGadget(Gui,GadgetNr)(a0,d0)
*/
long *RemoveGuiGadget(long newgui,long nr) {

    long size = 8 + 2*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_removeguigadget);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(nr);

    return (long *)ngcommand("RemoveGuiGadget",msgo,size,0);
}    
/*
ResizeGadget(Gui,GadgetNr,left,top,right,bottom)(a0,d0,d1,d2,d3,d4)
*/
long *ResizeGadget(long newgui,long nr,long l,long t,long r,long b) {

    long size = 8 + 6*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_resizegadget);
    msg[idx++]=big(6);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(nr);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(l);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(t);
    msg[idx++]=big(LABEL_D3);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(r);
    msg[idx++]=big(LABEL_D4);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(b);

    return (long *)ngcommand("ResizeGadget",msgo,size,0);
}    
/*
TransferGadget(OldGui,GadgetNr,NewGui)(a0,d0,a1)
*/
long *TransferGadget(long oldgui,long nr,long newgui) {

    long size = 8 + 3*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_transfergadget);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=oldgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(nr);
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("TransferGadget",msgo,size,0);
}    
/*
DrawBorderAroundBorder(Gui,Area)(a0,a1)
*/
long *DrawBorderAroundBorder(long newgui,long area) {

    long size = 8 + 2*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_drawborderaroundborder);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;

    return (long *)ngcommand("DrawBorderAroundBorder",msgo,size,0);
}    
/*
DrawBorderAroundBox(Gui,Area)(a0,a1)
*/
long *DrawBorderAroundBox(long newgui,long area) {

    long size = 8 + 2*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_drawborderaroundbox);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;

    return (long *)ngcommand("DrawBorderAroundBox",msgo,size,0);
}    
/*
DrawBorderAroundBasic(Gui,Area,DistantX,DistantY,size)(a0,a1,d0,d1,d2)
*/
long *DrawBorderAroundBasic(long newgui,long area,long distx,long disty,long bsize) {

    long size = 8 + 5*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_drawborderaroundbasic);
    msg[idx++]=big(5);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(distx);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(disty);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(bsize);

    return (long *)ngcommand("DrawBorderAroundBasic",msgo,size,0);
}    

/*
EraseBorderAroundBorder(Gui,Area,Red,Green,Blue)(a0,a1,d0,d1,d2)
*/
long *EraseBorderAroundBorder(long newgui,long area,long r,long g,long b) {

    long size = 8 + 5*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_eraseborderaroundborder);
    msg[idx++]=big(5);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(r);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(g);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(b);

    return (long *)ngcommand("EraseBorderAroundBorder",msgo,size,0);
}    

/*
EraseBorderAroundBox(Gui,Area,Red,Green,Blue)(a0,a1,d0,d1,d2)
*/
long *EraseBorderAroundBox(long newgui,long area,long r,long g,long b) {

    long size = 8 + 5*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_eraseborderaroundbox);
    msg[idx++]=big(5);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(r);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(g);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(b);

    return (long *)ngcommand("EraseBorderAroundBox",msgo,size,0);
}    
/*
EraseBorderAroundBasic(Gui,Area,DistantX,DistantY,size)(a0,a1,d0,d1,d2)
*/
long *EraseBorderAroundBasic(long newgui,long area,long x,long y,long s) {

    long size = 8 + 5*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_eraseborderaroundbasic);
    msg[idx++]=big(5);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(x);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(y);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(s);

    return (long *)ngcommand("EraseBorderAroundBasic",msgo,size,0);
}    
/*
EraseBorderAroundBorderPen(Gui,Area,Pen)(a0,a1,d0)
*/
long *EraseBorderAroundBorderPen(long newgui,long area,long pen) {

    long size = 8 + 3*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_eraseborderaroundborderpen);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(pen);

    return (long *)ngcommand("EraseBorderAroundBorderPen",msgo,size,0);
}    
/*
EraseBorderAroundBoxPen(Gui,Area,Pen)(a0,a1,d0)
*/
long *EraseBorderAroundBoxPen(long newgui,long area,long pen) {

    long size = 8 + 3*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_eraseborderaroundboxpen);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(pen);

    return (long *)ngcommand("EraseBorderAroundBoxPen",msgo,size,0);
}    
/*
HitBorder(Area,Mx,My)(a0,d0,d1)
*/
long *HitBorder(long area,long mx,long my) {

    long size = 8 + 3*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_hitborder);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(mx);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(my);

    return (long *)ngcommand("HitBorder",msgo,size,1);
}    

/*
GetRGB(Gui,Pen)(a0,d0)
*/
long *GetRGB(long newgui,long pen) {

    long size = 8 + 2*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getrgb);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(pen);


    return (long *)ngcommand("GetRGB",msgo,size,1);
}    
/*
MixDeep(Gui,Deep_bg,Deep_fg,Deep_Alpha)(a0,a1,a2,a3)
*/
long *MixDeep(long newgui,long bg,long fg,long alpha) {

    long size = 8 + 4*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_mixdeep);
    msg[idx++]=big(4);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=bg;
    msg[idx++]=big(LABEL_A2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=fg;
    msg[idx++]=big(LABEL_A3);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=alpha;

    return (long *)ngcommand("MixDeep",msgo,size,1);
}    
/*
UpdateGadget(Gui,GadgetNr,Tags)(a0,d0,a1)
*/
long *UpdateGadget(long newgui,long gadnbr,long *tags) {

    long size = 8 + 2*ARGINT;
    long idx =0;

    if (tags==NULL) {
        size=size+ARGBASE+LONG;
     } else {
        size=size+ARGBASE+tagsize(tags)*8;
    }

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_updategadget);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(gadnbr);

    if (tags!=NULL) {
   
    	msg[idx++]=big(LABEL_A1);msg[idx++]=big(POINTER);msg[idx++]=big(tagsize(tags)*8);
        msg= (long *)((long )msg+idx*4);
        memcpy( (char *)msg, tags, tagsize(tags)*8);
        msg= (long *)((long )msg+tagsize(tags)*8);

    } else {
    	msg[idx++]=big(LABEL_A1);msg[idx++]=big(LONG);msg[idx++]=0;

    }

    return (long *)ngcommand("UpdateGadget",msgo,size,0);
}    


/*
UpdateGadgetValue(Gui,GadgetNr,Var)(a0,d0,a1)
*/
long *UpdateGadgetValue(long newgui,long gadnbr,long *tags,long len) {

    long size = 8 + 2*ARGINT;
    long idx =0;

    if (tags==NULL) {
        size=size+ARGBASE+LONG;
     } else {
        size=size+ARGBASE+LONG+len;
    }

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_updategadgetvalue);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(gadnbr);

    msg[idx++]=big(LABEL_A1);msg[idx++]=big(POINTER);msg[idx++]=big(len);
    msg= (long *)((long )msg+idx*4);


    memcpy( (char *)msg, tags, len);
//    msg= (long *)((long )msg+len);

    return (long *)ngcommand("UpdateGadgetValue",msgo,size,0);
}    


/*
CropDeep(Deep,Left,Top,Width,Height,name)(a0,d0,d1,d2,d3,a1)
*/
long *CropDeep(long newgui,long l,long t,long w,long h,char *name) {

    long size = 8 + 5*ARGINT + ARGBASE + strlen(name)+1;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_cropdeep);
    msg[idx++]=big(6);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(l);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(t);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(w);
    msg[idx++]=big(LABEL_D3);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(h);

    msg[idx++]=big(LABEL_A1);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(name)+1);
        msg= (long *)((long )msg+idx*4);
        memcpy( (char *)msg, name, strlen(name)+1);
        msg= (long *)((long )msg+strlen(name)+1);

    return (long *)ngcommand("CropDeep",msgo,size,1);
}    

/*
PlaceColorText(Gui,Area,Text,fcolor,bcolor)(a0,a1,a2,d0,d1)
*/
long *PlaceColorText(long newgui,long area,char *text,long fg,long bg) {

    long size = 8 + 4*ARGINT + ARGBASE + strlen(text)+1;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_placecolortext);
    msg[idx++]=big(5);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;

    msg[idx++]=big(LABEL_A2);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(text)+1);
    msg= (long *)((long )msg+idx*4);
    memcpy( (char *)msg, text, strlen(text)+1);
    msg= (long *)((long )msg+strlen(text)+1);
    idx=0;

    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(fg);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(bg);

    return (long *)ngcommand("PlaceColorText",msgo,size,0);
}    

/*
PlaceText(Gui,Area,Text)(a0,a1,a2)
*/
long *PlaceText(long newgui,long area,char *text) {

    long size = 8 + 2*ARGINT + ARGBASE + strlen(text)+1;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_placetext);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;

    msg[idx++]=big(LABEL_A2);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(text)+1);
    msg= (long *)((long )msg+idx*4);
    memcpy( (char *)msg, text, strlen(text)+1);


    return (long *)ngcommand("PlaceText",msgo,size,0);
}    

/*
PlaceMultiText(Gui,Area,Text,dx,dy,fcolor,bcolor)(a0,a1,a2,d0,d1,d2,d3)
*/
long *PlaceMultiText(long newgui,long area,char *text,long dx,long dy,long fg,long bg) {

    long size = 8 + 6*ARGINT + ARGBASE + strlen(text)+1;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_placemultitext);
    msg[idx++]=big(7);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;

    msg[idx++]=big(LABEL_A2);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(text)+1);
    msg= (long *)((long )msg+idx*4);
    memcpy( (char *)msg, text, strlen(text)+1);
    msg= (long *)((long )msg+strlen(text)+1);
    idx=0;

    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(dx);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(dy);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(fg);
    msg[idx++]=big(LABEL_D3);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(bg);

    return (long *)ngcommand("PlaceMultiText",msgo,size,0);
}    

/*
SizeOfGui(Gui)(A0)
*/
long *SizeOfGui(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;
    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_sizeofgui);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("SizeOfGui",msgo,size,2);
}    

/*
NewString(String)(A0)
*/
long *NewString(char *text) {

    long size = 8 + ARGBASE + strlen(text)+1;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_newstring);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(text)+1);
    msg= (long *)((long )msg+idx*4);
    memcpy( (char *)msg, text, strlen(text)+1);

    return (long *)ngcommand("NewString",msgo,size,1);
}    
/*
FreeString(String)(A0)
*/
long *FreeString(long text) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_freestring);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=text;

    return (long *)ngcommand("FreeString",msgo,size,0);
}    

/*
Iconify(Gui)(a0)
*/
long *Iconify(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_iconify);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("Iconify",msgo,size,0);
}    

/*
SnapShot(Gui,Tags)(a0,a1)
*/
long *SnapShot(long newgui,long *tags) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    if (tags==NULL) {
        size=size+ARGBASE+LONG;
     } else {
        size=size+ARGBASE+tagsize(tags)*8;
    }

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_snapshot);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    if (tags!=NULL) {
   
    	msg[idx++]=big(LABEL_A1);msg[idx++]=big(POINTER);msg[idx++]=big(tagsize(tags)*8);
        msg= (long *)((long )msg+idx*4);
        memcpy( (char *)msg, tags, tagsize(tags)*8);
        msg= (long *)((long )msg+tagsize(tags)*8);

    } else {
    	msg[idx++]=big(LABEL_A1);msg[idx++]=big(LONG);msg[idx++]=0;

    }

    return (long *)ngcommand("SnapShot",msgo,size,1);
}    
/*
LoadSnapShot(Gui,Tags)(a0,a1)
*/
long *LoadSnapShot(long newgui,long *tags) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    if (tags==NULL) {
        size=size+ARGBASE+LONG;
     } else {
        size=size+ARGBASE+tagsize(tags)*8;
    }

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_loadsnapshot);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    if (tags!=NULL) {
   
    	msg[idx++]=big(LABEL_A1);msg[idx++]=big(POINTER);msg[idx++]=big(tagsize(tags)*8);
        msg= (long *)((long )msg+idx*4);
        memcpy( (char *)msg, tags, tagsize(tags)*8);
        msg= (long *)((long )msg+tagsize(tags)*8);

    } else {
    	msg[idx++]=big(LABEL_A1);msg[idx++]=big(LONG);msg[idx++]=0;

    }

    return (long *)ngcommand("LoadSnapShot",msgo,size,1);
}    
/*
PositionFromSnapShot(Gui,Gadget,left,top,width,height)(a0,d0,d1,d2,d3,d4)
*/
long *PositionFromSnapShot(long newgui,long gadnbr,long l,long t,long w,long h) {

    long size = 8 + 6*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_positionfromsnapshot);
    msg[idx++]=big(6);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(gadnbr);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(l);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(t);
    msg[idx++]=big(LABEL_D3);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(w);
    msg[idx++]=big(LABEL_D4);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(h);


    return (long *)ngcommand("PositionFromSnapShot",msgo,size,4);
}    
/*
UnSnapShot(Gui,Tags)(a0,a1)
*/
long *UnSnapShot(long newgui,long *tags) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    if (tags==NULL) {
        size=size+ARGBASE+LONG;
     } else {
        size=size+ARGBASE+tagsize(tags)*8;
    }

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_unsnapshot);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    if (tags!=NULL) {
   
    	msg[idx++]=big(LABEL_A1);msg[idx++]=big(POINTER);msg[idx++]=big(tagsize(tags)*8);
        msg= (long *)((long )msg+idx*4);
        memcpy( (char *)msg, tags, tagsize(tags)*8);
        msg= (long *)((long )msg+tagsize(tags)*8);

    } else {
    	msg[idx++]=big(LABEL_A1);msg[idx++]=big(LONG);msg[idx++]=0;
    }

    return (long *)ngcommand("UnSnapShot",msgo,size,0);
}    

/*
SetGadgetGFX(Gui,Gadget,normal,mouseover,select)(a0,d0,a1,a2,a3)
*/
long *SetGadgetGFX(long newgui,long gadget,long normal,long mouseover,long select) {

    long size = 8 + 4*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_setgadgetgfx);
    msg[idx++]=big(5);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=gadget;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=normal;
    msg[idx++]=big(LABEL_A2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=mouseover;
    msg[idx++]=big(LABEL_A3);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=select;

    return (long *)ngcommand("SetGadgetGFX",msgo,size,0);
}    

/*
SaveGadgetConfig(Gui,Class,tags)(A0,A1,A2)
*/
long *SaveGadgetConfig(long newgui,char *class,long *tags) {

    long size = 8 + 1*ARGINT + ARGBASE + strlen(class)+1;
    long idx =0;

    if (tags==NULL) {
        size=size+ARGBASE+LONG;
     } else {
        size=size+ARGBASE+tagsize(tags)*8;
    }

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_savegadgetconfig);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(class)+1);
    msg= (long *)((long )msg+idx*4);
    memcpy( (char *)msg, class, strlen(class)+1);
    msg= (long *)((long )msg+strlen(class)+1);idx=0;

    if (tags!=NULL) {
   
    	msg[idx++]=big(LABEL_A2);msg[idx++]=big(POINTER);msg[idx++]=big(tagsize(tags)*8);
        msg= (long *)((long )msg+idx*4);
        memcpy( (char *)msg, tags, tagsize(tags)*8);
        msg= (long *)((long )msg+tagsize(tags)*8);

    } else {
    	msg[idx++]=big(LABEL_A1);msg[idx++]=big(LONG);msg[idx++]=0;

    }

    return (long *)ngcommand("SaveGadgetConfig",msgo,size,0);
}    
/*
LoadGadgetConfig(Gui,Class)(A0,A1)
*/
long *LoadGadgetConfig(long newgui,char *class) {

    long size = 8 + 1*ARGINT + ARGBASE + strlen(class)+1;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_loadgadgetconfig);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    msg[idx++]=big(LABEL_A1);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(class)+1);
    msg= (long *)((long )msg+idx*4);
    memcpy( (char *)msg, class, strlen(class)+1);
    msg= (long *)((long )msg+strlen(class)+1);idx=0;

    return (long *)ngcommand("LoadGadgetConfig",msgo,size,1);
}    

/*
VisibleLines(Gui,Area)(A0,A1)
*/
long *VisibleLines(long newgui,long area) {

    long size = 8 + 2*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_visiblelines);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=area;

    return (long *)ngcommand("VisibleLines",msgo,size,1);
}    

/*
GetGadgetName(Gui,GadgetNr)(a0,d0)
*/
long *GetGadgetName(long newgui,long gadgetnr) {

    long size = 8 + 2*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getgadgetname);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(gadgetnr);

    return (long *)ngcommand("GetGadgetName",msgo,size,1);
}    

/*
GetGadgetAddr(Gui,GadgetNr)(a0,d0)
*/
long *GetGadgetAddr(long newgui,long gadgetnr) {

    long size = 8 + 2*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getgadgetaddr);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(gadgetnr);

    return (long *)ngcommand("GetGadgetAddr",msgo,size,1);
}    

/*
SetGadgetName(Gui,GadgetNr,NewName)(a0,d0,a1)
*/
long *SetGadgetName(long newgui,long gadgetnr,char *newname) {

    long size = 8 + 2*ARGINT + ARGBASE + strlen(newname)+1;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_setgadgetname);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(gadgetnr);
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(newname)+1);
    msg= (long *)((long )msg+idx*4);
    memcpy( (char *)msg, newname, strlen(newname)+1);
    msg= (long *)((long )msg+strlen(newname)+1);idx=0;

    return (long *)ngcommand("SetGadgetName",msgo,size,0);
}    
/*
GetPopMenuBase(Gui)(A0)
*/
long *GetPopMenuBase(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getpopmenubase);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("GetPopMenubase",msgo,size,1);
}    

/*
Activate_Gadget(Gui,GadgetNr)(a0,d0)
*/
long *Activate_Gadget(long newgui,long gadgetnr) {

    long size = 8 + 2*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_activate_gadget);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(gadgetnr);

    return (long *)ngcommand("Activate_Gadget",msgo,size,0);
}    
/*
DeActivate_Gadget(Gui,GadgetNr)(a0,d0)
*/
long *DeActivate_Gadget(long newgui,long gadgetnr) {

    long size = 8 + 2*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_deactivate_gadget);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(gadgetnr);

    return (long *)ngcommand("DeActivate_Gadget",msgo,size,0);
}    
/*
ObtainGui(Gui)(A0)
*/
long *ObtainGui(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_obtaingui);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("ObtainGui",msgo,size,0);
}    
/*
ReleaseGui(Gui)(A0)
*/
long *ReleaseGui(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_releasegui);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("ReleaseGui",msgo,size,0);
}    
/*
HowManyGuiClients(Gui)(A0)
*/
long *HowManyGuiClients(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_howmanyguiclients);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("HowManyGuiClients",msgo,size,0);
}    
/*
RemoveGuiGadgetByAddr(Gui,Addr)(a0,d0)
*/
long *RemoveGuiGadgetByAddr(long newgui,long addr) {

    long size = 8 + 2*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_removeguigadgetbyaddr);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=addr;

    return (long *)ngcommand("RemoveGuiGadgetByAddr",msgo,size,0);
}    

/*
GetGadgetValueByAddr(Gui,Addr)(a0,d0)
*/
long *GetGadgetValueByAddr(long newgui,long addr) {

    long size = 8 + 2*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getgadgetvaluebyaddr);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=addr;

    return (long *)ngcommand("GetGadgetValueByAddr",msgo,size,1);
}    

/*
GetGadgetValue(Gui,Addr)(a0,d0)
*/
long *GetGadgetValue(long newgui,long gnr) {

    long size = 8 + 2*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getgadgetvalue);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=gnr;

    return (long *)ngcommand("GetGadgetValue",msgo,size,1);
}


/*  
UpdateGadgetValueByAddr(Gui,Addr,Value)(a0,d0,a1)
*/

/*                   eine Funktion mit char* bauen! MSC              */

long *UpdateGadgetValueByAddr(long newgui,long addr,long value) {

    long size = 8 + 3*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_updategadgetvaluebyaddr);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=addr;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(value);

    return (long *)ngcommand("UpdateGadgetValueByAddr",msgo,size,0);
}    

/*
BrightDeep(Gui,Deep,Red,Green,Blue)(a0,a1,d0,d1,d2)
*/
long *BrightDeep(long newgui,long deep,long r,long g,long b) {

    long size = 8 + 5*ARGINT;
    long idx =0;


    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_brightdeep);
    msg[idx++]=big(5);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=deep;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(r);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(g);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(b);

    return (long *)ngcommand("BrightDeep",msgo,size,1);
}    
/*
LockGui(Gui)(a0)
*/
long *LockGui(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_lockgui);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("LockGui",msgo,size,1);
}    
/*
UnLockGui(Gui)(a0)
*/
long *UnLockGui(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_unlockgui);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("UnLockGui",msgo,size,1);
}    
/*
GetBorderSizes(Gui)(a0)
*/
long *GetBorderSizes(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getbordersizes);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("GetBorderSizes",msgo,size,1);
}    
/*
ScreenJump(Gui,Screen)(a0,a1)
*/
long *ScreenJump(long newgui,long screen) {

    long size = 8 + 2*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_screenjump);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=screen;

    return (long *)ngcommand("ScreenJump",msgo,size,1);
}    

/*
MakeEmptyDeep(Gui,Name,Width,Heigth)(a0,a1,d0,d1)
*/
long *MakeEmptyDeep(long newgui,char *text,long w,long h) {

    long size = 8 + 3*ARGINT + ARGBASE + strlen(text)+1;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_makeemptydeep);
    msg[idx++]=big(4);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(text)+1);

    msg= (long *)((long )msg+idx*4);
    memcpy( (char *)msg, text, strlen(text)+1);
    msg= (long *)((long )msg+strlen(text)+1);idx=0;

    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(w);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(h);

    return (long *)ngcommand("MakeEmptyDeep",msgo,size,1);
}    

/*
GetActiveGadget(Gui)(a0)
*/
long *GetActiveGadget(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getactivegadget);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("GetActiveGadget",msgo,size,1);
}    

/*
Activate_ListenGadget(Gui,GadgetNr)(a0,d0)
*/
long *Activate_ListenGadget(long newgui,long gadgetnr) {

    long size = 8 + 2*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_activate_listengadget);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(gadgetnr);

    return (long *)ngcommand("Activate_ListenGadget",msgo,size,0);
}    
/*
GuiToDeep(Gui,left,Top,Weite,Hoehe)(a0,d0,d1,d2,d3)
*/
long *GuiToDeep(long newgui,long l,long t,long w,long h) {

    long size = 8 + 5*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_guitodeep);
    msg[idx++]=big(5);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(l);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(t);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(w);
    msg[idx++]=big(LABEL_D3);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(h);

    return (long *)ngcommand("GuiToDeep",msgo,size,1);
}    

/*
ScreenToDeep(Gui,BitMap,Wrp,Left,Top,Weite,Top)(a2,a0,a1,d0,d1,d2,d3)
*/
long *ScreenToDeep(long newgui,long bitmap,long wrp,long l,long t,long w,long h) {

    long size = 8 + 7*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_screentodeep);
    msg[idx++]=big(7);

    msg[idx++]=big(LABEL_A2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=bitmap;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=wrp;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(l);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(t);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(w);
    msg[idx++]=big(LABEL_D3);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(h);

    return (long *)ngcommand("ScreenToDeep",msgo,size,1);
}    

/*
SaveDeep(Deep,Filename)(d0,a0)
*/
long *SaveDeep(long deep,char *text) {

    long size = 8 + 1*ARGINT + ARGBASE + strlen(text)+1;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_savedeep);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=deep;
    msg[idx++]=big(LABEL_A0);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(text)+1);

    msg= (long *)((long )msg+idx*4);
    memcpy( (char *)msg, text, strlen(text)+1);
    msg= (long *)((long )msg+strlen(text)+1);idx=0;

    return (long *)ngcommand("SaveDeep",msgo,size,0);
}    
/*
GetPixelFromDeep(Deep,X,Y)(a0,d0,d1)
*/
long *GetPixelFromDeep(long deep,long x,long y) {

    long size = 8 + 3*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getpixelfromdeep);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=deep;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(x);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(y);

    return (long *)ngcommand("GetPixelFromDeep",msgo,size,3);
}    

/*
FillDeep(Deep,R,G,B)(a0,d0,d1,d2)
*/
long *FillDeep(long deep,long r,long g,long b) {

    long size = 8 + 4*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_filldeep);
    msg[idx++]=big(4);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=deep;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(r);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(g);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(b);

    return (long *)ngcommand("FillDeep",msgo,size,0);
}    
/*
SetAlphaLevel(R,G,B)(d0,d1,d2)
*/
long *SetAlphaLevel(long r,long g,long b) {

    long size = 8 + 3*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_setalphalevel);
    msg[idx++]=big(3);

    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(r);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(g);
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(b);

    return (long *)ngcommand("SetAlphaLevel",msgo,size,0);
}    

/*
WhoIsOnline(Buffer,Len)(a0,d0)
*/
long *WhoIsOnline(long buffer,long len) {

/* NOTE: MSC : Buffer had to be a pointer returned by AllocMem(). As theres no TCP wrapper 
               for EXEC it won't work. Second, theres no way of retrieving the data yet!
*/

     printf("Sorry, WHOISONLINE can not be called from a client, it won't work proper!\n");     
     return NULL;
}    

/*
IsOnline(Gui)(d0)
*/
long *IsOnline(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_isonline);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("IsOnline",msgo,size,1);
}    

/*
GetIconifyState(Gui)(a0)
*/
long *GetIconifyState(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_geticonifystate);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("GetIconifyState",msgo,size,1);
}    

/*
GenericRequester(Gui,text,gadgets,tags)(a0,a1,a2,a3)
*/
long *GenericRequester(long newgui,char *text,char *gadgettext,long *tags) {

    long size = 8 + 1*ARGINT + ARGBASE + strlen(text)+1+ ARGBASE + strlen(gadgettext)+1;
    long idx =0;

    if (tags==NULL) {
        size=size+ARGBASE+LONG;
     } else {
        size=size+ARGBASE+tagsize(tags)*8;
    }

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_genericrequester);
    msg[idx++]=big(4);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    msg[idx++]=big(LABEL_A1);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(text)+1);

    msg= (long *)((long )msg+idx*4);
    memcpy( (char *)msg, text, strlen(text)+1);
    msg= (long *)((long )msg+strlen(text)+1);idx=0;

    msg[idx++]=big(LABEL_A2);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(gadgettext)+1);

    msg= (long *)((long )msg+idx*4);
    memcpy( (char *)msg, text, strlen(gadgettext)+1);
    msg= (long *)((long )msg+strlen(gadgettext)+1);idx=0;


    if (tags!=NULL) {
   
    	msg[idx++]=big(LABEL_A3);msg[idx++]=big(POINTER);msg[idx++]=big(tagsize(tags)*8);
        msg= (long *)((long )msg+idx*4);
        memcpy( (char *)msg, tags, tagsize(tags)*8);
        msg= (long *)((long )msg+tagsize(tags)*8);

    } else {
    	msg[idx++]=big(LABEL_A3);msg[idx++]=big(LONG);msg[idx++]=0;

    }
    
    return (long *)ngcommand("GenericRequester",msgo,size,1);
}    

/*
CopyDeep(SourceDeep,sx,sy,sw,sh,DestDeep,dx,dy)(a0,d0,d1,d2,d3,a1,d4,d5)
*/
long *CopyDeep(long sdeep,long sx,long sy,long sw,long sh,long ddeep,long dx,long dy) {

    long size = 8 + 8*ARGINT;
    long idx =0;


    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_copydeep);
    msg[idx++]=big(8);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=sdeep;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=sx;
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=sy;
    msg[idx++]=big(LABEL_D2);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=sw;
    msg[idx++]=big(LABEL_D3);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=sh;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=ddeep;
    msg[idx++]=big(LABEL_D4);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=dx;
    msg[idx++]=big(LABEL_D5);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=dy;

    return (long *)ngcommand("CopyDeep",msgo,size,0);
}    

/*
MakeThemeGFX(Gui,width,height,classname,backgrounddeep)(a0,d0,d1,a1,a2)
*/
long *MakeThemeGFX(long newgui,long w,long h,char *text,long deep) {

    long size = 8 + 4*ARGINT + ARGBASE + strlen(text)+1;
    long idx =0;


    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_makethemegfx);
    msg[idx++]=big(5);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(w);
    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(h);

    msg[idx++]=big(LABEL_A1);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(text)+1);

    msg= (long *)((long )msg+idx*4);
    memcpy( (char *)msg, text, strlen(text)+1);
    msg= (long *)((long )msg+strlen(text)+1);idx=0;

    msg[idx++]=big(LABEL_D1);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=deep;
    
    return (long *)ngcommand("MakeThemeGFX",msgo,size,3);
}    

/*
CreateDeepTheme(Gui,classname)(a0,a1)
*/
long *CreateDeepTheme(long newgui,char *text) {

    long size = 8 + 1*ARGINT + ARGBASE + strlen(text)+1;
    long idx =0;


    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_createdeeptheme);
    msg[idx++]=big(2);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;
    msg[idx++]=big(LABEL_A1);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(text)+1);

    msg= (long *)((long )msg+idx*4);
    memcpy( (char *)msg, text, strlen(text)+1);
    msg= (long *)((long )msg+strlen(text)+1);idx=0;

    return (long *)ngcommand("CreateDeepTheme",msgo,size,1);
}    

/*
getThemeNameByID(ID)(d0)
*/
long *getThemeNameByID(long id) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getthemenamebyid);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_D0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=big(id);

    return (long *)ngcommand("getThemeNameByID",msgo,size,1);
}    
/*
getThemeNameFromGui(Gui)(a0)
*/
long *getThemeNameFromGui(long newgui) {

    long size = 8 + 1*ARGINT;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getthemenamefromgui);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(INT);msg[idx++]=big(LONG);msg[idx++]=newgui;

    return (long *)ngcommand("getThemeNameFromGui",msgo,size,1);
}    

/*
getThemeByName(themename)(a0)
*/
long *getThemeByName(char *text) {

    long size = 8 + ARGBASE + strlen(text)+1;
    long idx =0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc_getthemebyname);
    msg[idx++]=big(1);

    msg[idx++]=big(LABEL_A0);msg[idx++]=big(POINTER);msg[idx++]=big(strlen(text)+1);

    msg= (long *)((long )msg+idx*4);
    memcpy( (char *)msg, text, strlen(text)+1);
    msg= (long *)((long )msg+strlen(text)+1);idx=0;

    return (long *)ngcommand("getThemeByName",msgo,size,1);
}    

/*
_getAmigaString(Buffer)(a0)
*/
char * _getAmigaString(long buffer) {

    long size = 8;
    long idx = 0;

    char *msgo =  malloc (size);
    long *msg=(long *)msgo;

    msg[idx++]=big(fc__getAmigaString);
    msg[idx++]=buffer;

    return (char *)ngcommand("_getAmigaString",msgo,size,1);
}    
